package wf.servitor.common.config

import com.uchuhimo.konf.ConfigSpec

object QueueSpec : ConfigSpec() {
    val url by optional("tcp://localhost:61616", description = "url of ActiveMQ server")
    val username by optional<String?>(null, description = "username for ActiveMQ server")
    val password by optional<String?>(null, description = "password for ActiveMQ server")

    object Names : ConfigSpec() {
        val namePrefix by optional(
            "servitor",
            name = "prefix",
            description = "the prefix of all queues and addresses used in ActiveMQ"
        )

        val task by optional(
            "task",
            description = "the name of the task address, the queue will always appear at [prefix].[task].queue"
        )

        val observation by optional(
            "observe",
            description = "the name of the observation queue, which will listen to all messages send to [prefix].#"
        )

        val relay by optional(
            "relay",
            description = "the name of the relay address, the queue will appear at [prefix].[relay].queue"
        )
    }
}


