package wf.servitor.common.workflow

import com.fasterxml.jackson.databind.DeserializationFeature
import com.fasterxml.jackson.databind.ObjectMapper
import com.fasterxml.jackson.databind.PropertyNamingStrategy
import com.fasterxml.jackson.dataformat.yaml.YAMLFactory
import com.fasterxml.jackson.module.kotlin.registerKotlinModule
import wf.servitor.common.utils.JacksonModule

object Jackson {
    val yaml = ObjectMapper(YAMLFactory()).apply {
        registerKotlinModule()
        registerModule(JacksonModule)
        disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES)
        propertyNamingStrategy = PropertyNamingStrategy.LOWER_CAMEL_CASE
    }

    val json = ObjectMapper().apply {
        registerKotlinModule()
        registerModule(JacksonModule)
        propertyNamingStrategy = PropertyNamingStrategy.LOWER_CAMEL_CASE
    }
}